diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index f976c0e5c7e..8cdfea1ccfb 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -16241,11 +16316,7 @@ ATExecChangeOwner(Oid relationOid, Oid newOwnerId, bool recursing, LOCKMODE lock
 			}
 		}
 
-		memset(repl_null, false, sizeof(repl_null));
-		memset(repl_repl, false, sizeof(repl_repl));
-
-		repl_repl[Anum_pg_class_relowner - 1] = true;
-		repl_val[Anum_pg_class_relowner - 1] = ObjectIdGetDatum(newOwnerId);
+		HeapTupleUpdateValue(pg_class, relowner, ObjectIdGetDatum(newOwnerId), values, nulls, updated);
 
 		/*
 		 * Determine the modified ACL for the new owner.  This is only
@@ -16258,14 +16329,14 @@ ATExecChangeOwner(Oid relationOid, Oid newOwnerId, bool recursing, LOCKMODE lock
 		{
 			newAcl = aclnewowner(DatumGetAclP(aclDatum),
 								 tuple_class->relowner, newOwnerId);
-			repl_repl[Anum_pg_class_relacl - 1] = true;
-			repl_val[Anum_pg_class_relacl - 1] = PointerGetDatum(newAcl);
+			HeapTupleUpdateValue(pg_class, relacl, PointerGetDatum(newAcl), values, nulls, updated);
 		}
 
-		newtuple = heap_modify_tuple(tuple, RelationGetDescr(class_rel), repl_val, repl_null, repl_repl);
+		newtuple = heap_update_tuple(tuple, RelationGetDescr(class_rel), values, nulls, updated);
 
-		CatalogTupleUpdate(class_rel, &newtuple->t_self, newtuple);
+		CatalogTupleUpdate(class_rel, &newtuple->t_self, newtuple, updated, NULL);
 
+		bms_free(updated);
 		heap_freetuple(newtuple);
 
 		/*
@@ -16357,9 +16428,9 @@ change_owner_fix_column_acls(Oid relationOid, Oid oldOwnerId, Oid newOwnerId)
 	while (HeapTupleIsValid(attributeTuple = systable_getnext(scan)))
 	{
 		Form_pg_attribute att = (Form_pg_attribute) GETSTRUCT(attributeTuple);
-		Datum		repl_val[Natts_pg_attribute];
-		bool		repl_null[Natts_pg_attribute];
-		bool		repl_repl[Natts_pg_attribute];
+		Datum		values[Natts_pg_attribute] = {0};
+		bool		nulls[Natts_pg_attribute] = {false};
+		Bitmapset  *updated = NULL;
 		Acl		   *newAcl;
 		Datum		aclDatum;
 		bool		isNull;
@@ -16377,20 +16448,17 @@ change_owner_fix_column_acls(Oid relationOid, Oid oldOwnerId, Oid newOwnerId)
 		if (isNull)
 			continue;
 
-		memset(repl_null, false, sizeof(repl_null));
-		memset(repl_repl, false, sizeof(repl_repl));
-
 		newAcl = aclnewowner(DatumGetAclP(aclDatum),
 							 oldOwnerId, newOwnerId);
-		repl_repl[Anum_pg_attribute_attacl - 1] = true;
-		repl_val[Anum_pg_attribute_attacl - 1] = PointerGetDatum(newAcl);
+		HeapTupleUpdateValue(pg_attribute, attacl, PointerGetDatum(newAcl), values, nulls, updated);
 
-		newtuple = heap_modify_tuple(attributeTuple,
+		newtuple = heap_update_tuple(attributeTuple,
 									 RelationGetDescr(attRelation),
-									 repl_val, repl_null, repl_repl);
+									 values, nulls, updated);
 
-		CatalogTupleUpdate(attRelation, &newtuple->t_self, newtuple);
+		CatalogTupleUpdate(attRelation, &newtuple->t_self, newtuple, updated, NULL);
 
+		bms_free(updated);
 		heap_freetuple(newtuple);
 	}
 	systable_endscan(scan);
@@ -16559,6 +16627,7 @@ ATExecSetAccessMethodNoStorage(Relation rel, Oid newAccessMethodId)
 	HeapTuple	tuple;
 	Form_pg_class rd_rel;
 	Oid			reloid = RelationGetRelid(rel);
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Shouldn't be called on relations having storage; these are processed in
@@ -16576,17 +16645,18 @@ ATExecSetAccessMethodNoStorage(Relation rel, Oid newAccessMethodId)
 
 	/* Update the pg_class row. */
 	oldAccessMethodId = rd_rel->relam;
-	rd_rel->relam = newAccessMethodId;
+	HeapTupleUpdateField(pg_class, relam, newAccessMethodId, rd_rel, updated);
 
 	/* Leave if no update required */
 	if (rd_rel->relam == oldAccessMethodId)
 	{
+		bms_free(updated);
 		heap_freetuple(tuple);
 		table_close(pg_class, RowExclusiveLock);
 		return;
 	}
 
-	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple);
+	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple, updated, NULL);
 
 	/*
 	 * Update the dependency on the new access method.  No dependency is added
@@ -16634,6 +16704,7 @@ ATExecSetAccessMethodNoStorage(Relation rel, Oid newAccessMethodId)
 
 	InvokeObjectPostAlterHook(RelationRelationId, RelationGetRelid(rel), 0);
 
+	bms_free(updated);
 	heap_freetuple(tuple);
 	table_close(pg_class, RowExclusiveLock);
 }
@@ -16681,9 +16752,9 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 	HeapTuple	newtuple;
 	Datum		datum;
 	Datum		newOptions;
-	Datum		repl_val[Natts_pg_class];
-	bool		repl_null[Natts_pg_class];
-	bool		repl_repl[Natts_pg_class];
+	Datum		values[Natts_pg_class] = {0};
+	bool		nulls[Natts_pg_class] = {false};
+	Bitmapset  *updated = NULL;
 	const char *const validnsps[] = HEAP_RELOPT_NAMESPACES;
 
 	if (defList == NIL && operation != AT_ReplaceRelOptions)
@@ -16785,25 +16856,23 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 	 * All we need do here is update the pg_class row; the new options will be
 	 * propagated into relcaches during post-commit cache inval.
 	 */
-	memset(repl_val, 0, sizeof(repl_val));
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
 
 	if (newOptions != (Datum) 0)
-		repl_val[Anum_pg_class_reloptions - 1] = newOptions;
+		HeapTupleUpdateValue(pg_class, reloptions, newOptions, values, nulls, updated);
 	else
-		repl_null[Anum_pg_class_reloptions - 1] = true;
+		HeapTupleUpdateValueNull(pg_class, reloptions, values, nulls, updated);
 
-	repl_repl[Anum_pg_class_reloptions - 1] = true;
+	newtuple = heap_update_tuple(tuple, RelationGetDescr(pgclass),
+								 values, nulls, updated);
 
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(pgclass),
-								 repl_val, repl_null, repl_repl);
+	CatalogTupleUpdate(pgclass, &newtuple->t_self, newtuple, updated, NULL);
 
-	CatalogTupleUpdate(pgclass, &newtuple->t_self, newtuple);
 	UnlockTuple(pgclass, &tuple->t_self, InplaceUpdateTupleLock);
 
 	InvokeObjectPostAlterHook(RelationRelationId, RelationGetRelid(rel), 0);
 
+	bms_free(updated);
+	updated = NULL;
 	heap_freetuple(newtuple);
 
 	ReleaseSysCache(tuple);
@@ -16845,26 +16914,25 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 
 		(void) heap_reloptions(RELKIND_TOASTVALUE, newOptions, true);
 
-		memset(repl_val, 0, sizeof(repl_val));
-		memset(repl_null, false, sizeof(repl_null));
-		memset(repl_repl, false, sizeof(repl_repl));
+		memset(values, 0, sizeof(values));
+		memset(nulls, false, sizeof(nulls));
+		Assert(bms_is_empty(updated));
 
 		if (newOptions != (Datum) 0)
-			repl_val[Anum_pg_class_reloptions - 1] = newOptions;
+			HeapTupleUpdateValue(pg_class, reloptions, newOptions, values, nulls, updated);
 		else
-			repl_null[Anum_pg_class_reloptions - 1] = true;
-
-		repl_repl[Anum_pg_class_reloptions - 1] = true;
+			HeapTupleUpdateValueNull(pg_class, reloptions, values, nulls, updated);
 
-		newtuple = heap_modify_tuple(tuple, RelationGetDescr(pgclass),
-									 repl_val, repl_null, repl_repl);
+		newtuple = heap_update_tuple(tuple, RelationGetDescr(pgclass),
+									 values, nulls, updated);
 
-		CatalogTupleUpdate(pgclass, &newtuple->t_self, newtuple);
+		CatalogTupleUpdate(pgclass, &newtuple->t_self, newtuple, updated, NULL);
 
 		InvokeObjectPostAlterHookArg(RelationRelationId,
 									 RelationGetRelid(toastrel), 0,
 									 InvalidOid, true);
 
+		bms_free(updated);
 		heap_freetuple(newtuple);
 
 		ReleaseSysCache(tuple);
@@ -17536,6 +17604,7 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel, bool ispart
 	for (AttrNumber parent_attno = 1; parent_attno <= parent_desc->natts; parent_attno++)
 	{
 		Form_pg_attribute parent_att = TupleDescAttr(parent_desc, parent_attno - 1);
+		Bitmapset  *updated = NULL;
 		char	   *parent_attname = NameStr(parent_att->attname);
 		HeapTuple	tuple;
 
@@ -17620,6 +17689,8 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel, bool ispart
 						errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
 						errmsg("too many inheritance parents"));
 
+			HeapTupleMarkColumnUpdated(pg_attribute, attinhcount, updated);
+
 			/*
 			 * In case of partitions, we must enforce that value of attislocal
 			 * is same in all partitions. (Note: there are only inherited
@@ -17628,10 +17699,12 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel, bool ispart
 			if (parent_rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
 			{
 				Assert(child_att->attinhcount == 1);
-				child_att->attislocal = false;
+				HeapTupleUpdateField(pg_attribute, attislocal, false, child_att, updated);
 			}
 
-			CatalogTupleUpdate(attrrel, &tuple->t_self, tuple);
+			CatalogTupleUpdate(attrrel, &tuple->t_self, tuple, updated, NULL);
+
+			bms_free(updated);
 			heap_freetuple(tuple);
 		}
 		else
@@ -17694,6 +17767,7 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 		HeapTuple	child_tuple;
 		AttrNumber	parent_attno;
 		bool		found = false;
+		Bitmapset  *updated = NULL;
 
 		if (parent_con->contype != CONSTRAINT_CHECK &&
 			parent_con->contype != CONSTRAINT_NOTNULL)
@@ -17802,6 +17876,8 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 						errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
 						errmsg("too many inheritance parents"));
 
+			HeapTupleMarkColumnUpdated(pg_constraint, coninhcount, updated);
+
 			/*
 			 * In case of partitions, an inherited constraint must be
 			 * inherited only once since it cannot have multiple parents and
@@ -17810,10 +17886,12 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 			if (parent_rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
 			{
 				Assert(child_con->coninhcount == 1);
-				child_con->conislocal = false;
+				HeapTupleUpdateField(pg_constraint, conislocal, false, child_con, updated);
 			}
 
-			CatalogTupleUpdate(constraintrel, &child_copy->t_self, child_copy);
+			CatalogTupleUpdate(constraintrel, &child_copy->t_self, child_copy, updated, NULL);
+
+			bms_free(updated);
 			heap_freetuple(child_copy);
 
 			found = true;
@@ -17917,6 +17995,7 @@ MarkInheritDetached(Relation child_rel, Relation parent_rel)
 	while (HeapTupleIsValid(inheritsTuple = systable_getnext(scan)))
 	{
 		Form_pg_inherits inhForm;
+		Bitmapset  *updated = NULL;
 
 		inhForm = (Form_pg_inherits) GETSTRUCT(inheritsTuple);
 		if (inhForm->inhdetachpending)
@@ -17931,14 +18010,18 @@ MarkInheritDetached(Relation child_rel, Relation parent_rel)
 		if (inhForm->inhrelid == RelationGetRelid(child_rel))
 		{
 			HeapTuple	newtup;
+			Form_pg_inherits classForm;
 
 			newtup = heap_copytuple(inheritsTuple);
-			((Form_pg_inherits) GETSTRUCT(newtup))->inhdetachpending = true;
+			classForm = (Form_pg_inherits) GETSTRUCT(newtup);
+
+			HeapTupleUpdateField(pg_inherits, inhdetachpending, true, classForm, updated);
+
+			CatalogTupleUpdate(catalogRelation, &inheritsTuple->t_self, newtup, updated, NULL);
 
-			CatalogTupleUpdate(catalogRelation,
-							   &inheritsTuple->t_self,
-							   newtup);
 			found = true;
+
+			bms_free(updated);
 			heap_freetuple(newtup);
 			/* keep looking, to ensure we catch others pending detach */
 		}
@@ -18023,6 +18106,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 	while (HeapTupleIsValid(attributeTuple = systable_getnext(scan)))
 	{
 		Form_pg_attribute att = (Form_pg_attribute) GETSTRUCT(attributeTuple);
+		Bitmapset  *updated = NULL;
 
 		/* Ignore if dropped or not inherited */
 		if (att->attisdropped)
@@ -18037,11 +18121,14 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 			HeapTuple	copyTuple = heap_copytuple(attributeTuple);
 			Form_pg_attribute copy_att = (Form_pg_attribute) GETSTRUCT(copyTuple);
 
-			copy_att->attinhcount--;
+			HeapTupleUpdateField(pg_attribute, attinhcount, copy_att->attinhcount - 1, copy_att, updated);
+
 			if (copy_att->attinhcount == 0)
-				copy_att->attislocal = true;
+				HeapTupleUpdateField(pg_attribute, attislocal, true, copy_att, updated);
 
-			CatalogTupleUpdate(catalogRelation, &copyTuple->t_self, copyTuple);
+			CatalogTupleUpdate(catalogRelation, &copyTuple->t_self, copyTuple, updated, NULL);
+
+			bms_free(updated);
 			heap_freetuple(copyTuple);
 		}
 	}
@@ -18103,6 +18190,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 	{
 		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(constraintTuple);
 		bool		match = false;
+		Bitmapset  *updated = NULL;
 
 		/*
 		 * Match CHECK constraints by name, not-null constraints by column
@@ -18148,11 +18236,14 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 				elog(ERROR, "relation %u has non-inherited constraint \"%s\"",
 					 RelationGetRelid(child_rel), NameStr(copy_con->conname));
 
-			copy_con->coninhcount--;
+			HeapTupleUpdateField(pg_constraint, coninhcount, copy_con->coninhcount - 1, copy_con, updated);
+
 			if (copy_con->coninhcount == 0)
-				copy_con->conislocal = true;
+				HeapTupleUpdateField(pg_constraint, conislocal, true, copy_con, updated);
 
-			CatalogTupleUpdate(catalogRelation, &copyTuple->t_self, copyTuple);
+			CatalogTupleUpdate(catalogRelation, &copyTuple->t_self, copyTuple, updated, NULL);
+
+			bms_free(updated);
 			heap_freetuple(copyTuple);
 		}
 	}
@@ -18258,6 +18349,7 @@ ATExecAddOf(Relation rel, const TypeName *ofTypename, LOCKMODE lockmode)
 	ObjectAddress tableobj,
 				typeobj;
 	HeapTuple	classtuple;
+	Bitmapset  *updated = NULL;
 
 	/* Validate the type. */
 	typetuple = typenameType(NULL, ofTypename, NULL);
@@ -18363,11 +18455,14 @@ ATExecAddOf(Relation rel, const TypeName *ofTypename, LOCKMODE lockmode)
 	classtuple = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(classtuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	((Form_pg_class) GETSTRUCT(classtuple))->reloftype = typeid;
-	CatalogTupleUpdate(relationRelation, &classtuple->t_self, classtuple);
+
+	HeapTupleUpdateField(pg_class, reloftype, typeid, (Form_pg_class) GETSTRUCT(classtuple), updated);
+
+	CatalogTupleUpdate(relationRelation, &classtuple->t_self, classtuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(RelationRelationId, relid, 0);
 
+	bms_free(updated);
 	heap_freetuple(classtuple);
 	table_close(relationRelation, RowExclusiveLock);
 
@@ -18388,6 +18483,7 @@ ATExecDropOf(Relation rel, LOCKMODE lockmode)
 	Oid			relid = RelationGetRelid(rel);
 	Relation	relationRelation;
 	HeapTuple	tuple;
+	Bitmapset  *updated = NULL;
 
 	if (!OidIsValid(rel->rd_rel->reloftype))
 		ereport(ERROR,
@@ -18408,11 +18504,14 @@ ATExecDropOf(Relation rel, LOCKMODE lockmode)
 	tuple = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	((Form_pg_class) GETSTRUCT(tuple))->reloftype = InvalidOid;
-	CatalogTupleUpdate(relationRelation, &tuple->t_self, tuple);
+
+	HeapTupleUpdateField(pg_class, reloftype, InvalidOid, (Form_pg_class) GETSTRUCT(tuple), updated);
+
+	CatalogTupleUpdate(relationRelation, &tuple->t_self, tuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(RelationRelationId, relid, 0);
 
+	bms_free(updated);
 	heap_freetuple(tuple);
 	table_close(relationRelation, RowExclusiveLock);
 }
@@ -18450,8 +18549,11 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 	pg_class_form = (Form_pg_class) GETSTRUCT(pg_class_tuple);
 	if (pg_class_form->relreplident != ri_type)
 	{
-		pg_class_form->relreplident = ri_type;
-		CatalogTupleUpdate(pg_class, &pg_class_tuple->t_self, pg_class_tuple);
+		Bitmapset  *updated = NULL;
+
+		HeapTupleUpdateField(pg_class, relreplident, ri_type, pg_class_form, updated);
+		CatalogTupleUpdate(pg_class, &pg_class_tuple->t_self, pg_class_tuple, updated, NULL);
+		bms_free(updated);
 	}
 	table_close(pg_class, RowExclusiveLock);
 	heap_freetuple(pg_class_tuple);
@@ -18464,6 +18566,7 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 	{
 		Oid			thisIndexOid = lfirst_oid(index);
 		bool		dirty = false;
+		Bitmapset  *updated = NULL;
 
 		pg_index_tuple = SearchSysCacheCopy1(INDEXRELID,
 											 ObjectIdGetDatum(thisIndexOid));
@@ -18477,7 +18580,7 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 			if (!pg_index_form->indisreplident)
 			{
 				dirty = true;
-				pg_index_form->indisreplident = true;
+				HeapTupleUpdateField(pg_index, indisreplident, true, pg_index_form, updated);
 			}
 		}
 		else
@@ -18486,13 +18589,13 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 			if (pg_index_form->indisreplident)
 			{
 				dirty = true;
-				pg_index_form->indisreplident = false;
+				HeapTupleUpdateField(pg_index, indisreplident, false, pg_index_form, updated);
 			}
 		}
 
 		if (dirty)
 		{
-			CatalogTupleUpdate(pg_index, &pg_index_tuple->t_self, pg_index_tuple);
+			CatalogTupleUpdate(pg_index, &pg_index_tuple->t_self, pg_index_tuple, updated, NULL);
 			InvokeObjectPostAlterHookArg(IndexRelationId, thisIndexOid, 0,
 										 InvalidOid, is_internal);
 
@@ -18505,6 +18608,7 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 			 */
 			CacheInvalidateRelcache(rel);
 		}
+		bms_free(updated);
 		heap_freetuple(pg_index_tuple);
 	}
 
@@ -18634,6 +18738,7 @@ ATExecSetRowSecurity(Relation rel, bool rls)
 	Relation	pg_class;
 	Oid			relid;
 	HeapTuple	tuple;
+	Bitmapset  *updated = NULL;
 
 	relid = RelationGetRelid(rel);
 
@@ -18645,13 +18750,14 @@ ATExecSetRowSecurity(Relation rel, bool rls)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 
-	((Form_pg_class) GETSTRUCT(tuple))->relrowsecurity = rls;
-	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple);
+	HeapTupleUpdateField(pg_class, relrowsecurity, rls, (Form_pg_class) GETSTRUCT(tuple), updated);
+	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel), 0);
 
 	table_close(pg_class, RowExclusiveLock);
+	bms_free(updated);
 	heap_freetuple(tuple);
 }
 
@@ -18664,6 +18770,7 @@ ATExecForceNoForceRowSecurity(Relation rel, bool force_rls)
 	Relation	pg_class;
 	Oid			relid;
 	HeapTuple	tuple;
+	Bitmapset  *updated = NULL;
 
 	relid = RelationGetRelid(rel);
 
@@ -18674,13 +18781,14 @@ ATExecForceNoForceRowSecurity(Relation rel, bool force_rls)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 
-	((Form_pg_class) GETSTRUCT(tuple))->relforcerowsecurity = force_rls;
-	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple);
+	HeapTupleUpdateField(pg_class, relforcerowsecurity, force_rls, (Form_pg_class) GETSTRUCT(tuple), updated);
+	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel), 0);
 
 	table_close(pg_class, RowExclusiveLock);
+	bms_free(updated);
 	heap_freetuple(tuple);
 }
 
@@ -18695,9 +18803,9 @@ ATExecGenericOptions(Relation rel, List *options)
 	ForeignDataWrapper *fdw;
 	HeapTuple	tuple;
 	bool		isnull;
-	Datum		repl_val[Natts_pg_foreign_table];
-	bool		repl_null[Natts_pg_foreign_table];
-	bool		repl_repl[Natts_pg_foreign_table];
+	Datum		values[Natts_pg_foreign_table] = {0};
+	bool		nulls[Natts_pg_foreign_table] = {false};
+	Bitmapset  *updated = NULL;
 	Datum		datum;
 	Form_pg_foreign_table tableform;
 
@@ -18717,10 +18825,6 @@ ATExecGenericOptions(Relation rel, List *options)
 	server = GetForeignServer(tableform->ftserver);
 	fdw = GetForeignDataWrapper(server->fdwid);
 
-	memset(repl_val, 0, sizeof(repl_val));
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
-
 	/* Extract the current options */
 	datum = SysCacheGetAttr(FOREIGNTABLEREL,
 							tuple,
@@ -18736,18 +18840,16 @@ ATExecGenericOptions(Relation rel, List *options)
 									fdw->fdwvalidator);
 
 	if (DatumGetPointer(datum) != NULL)
-		repl_val[Anum_pg_foreign_table_ftoptions - 1] = datum;
+		HeapTupleUpdateValue(pg_foreign_table, ftoptions, datum, values, nulls, updated);
 	else
-		repl_null[Anum_pg_foreign_table_ftoptions - 1] = true;
-
-	repl_repl[Anum_pg_foreign_table_ftoptions - 1] = true;
+		HeapTupleUpdateValueNull(pg_foreign_table, ftoptions, values, nulls, updated);
 
 	/* Everything looks good - update the tuple */
 
-	tuple = heap_modify_tuple(tuple, RelationGetDescr(ftrel),
-							  repl_val, repl_null, repl_repl);
+	tuple = heap_update_tuple(tuple, RelationGetDescr(ftrel),
+							  values, nulls, updated);
 
-	CatalogTupleUpdate(ftrel, &tuple->t_self, tuple);
+	CatalogTupleUpdate(ftrel, &tuple->t_self, tuple, updated, NULL);
 
 	/*
 	 * Invalidate relcache so that all sessions will refresh any cached plans
@@ -18760,6 +18862,7 @@ ATExecGenericOptions(Relation rel, List *options)
 
 	table_close(ftrel, RowExclusiveLock);
 
+	bms_free(updated);
 	heap_freetuple(tuple);
 }
 
@@ -18781,6 +18884,7 @@ ATExecSetCompression(Relation rel,
 	char	   *compression;
 	char		cmethod;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	compression = strVal(newValue);
 
@@ -18809,8 +18913,8 @@ ATExecSetCompression(Relation rel,
 	cmethod = GetAttributeCompression(atttableform->atttypid, compression);
 
 	/* update pg_attribute entry */
-	atttableform->attcompression = cmethod;
-	CatalogTupleUpdate(attrel, &tuple->t_self, tuple);
+	HeapTupleUpdateField(pg_attribute, attcompression, cmethod, atttableform, updated);
+	CatalogTupleUpdate(attrel, &tuple->t_self, tuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -18825,6 +18929,7 @@ ATExecSetCompression(Relation rel,
 							  true, cmethod,
 							  lockmode);
 
+	bms_free(updated);
 	heap_freetuple(tuple);
 
 	table_close(attrel, RowExclusiveLock);
@@ -19088,6 +19193,7 @@ AlterRelationNamespaceInternal(Relation classRel, Oid relOid,
 	Form_pg_class classForm;
 	ObjectAddress thisobj;
 	bool		already_done = false;
+	Bitmapset  *updated = NULL;
 
 	/* no rel lock for relkind=c so use LOCKTAG_TUPLE */
 	classTup = SearchSysCacheLockedCopy1(RELOID, ObjectIdGetDatum(relOid));
@@ -19121,9 +19227,10 @@ AlterRelationNamespaceInternal(Relation classRel, Oid relOid,
 							get_namespace_name(newNspOid))));
 
 		/* classTup is a copy, so OK to scribble on */
-		classForm->relnamespace = newNspOid;
+		HeapTupleUpdateField(pg_class, relnamespace, newNspOid, classForm, updated);
 
-		CatalogTupleUpdate(classRel, &otid, classTup);
+		CatalogTupleUpdate(classRel, &otid, classTup, updated, NULL);
+		bms_free(updated);
 		UnlockTuple(classRel, &otid, InplaceUpdateTupleLock);
 
 
@@ -21134,9 +21241,9 @@ DetachPartitionFinalize(Relation rel, Relation partRel, bool concurrent,
 	List	   *fks;
 	ListCell   *cell;
 	List	   *indexes;
-	Datum		new_val[Natts_pg_class];
-	bool		new_null[Natts_pg_class],
-				new_repl[Natts_pg_class];
+	Datum		new_val[Natts_pg_class] = {0};
+	bool		new_null[Natts_pg_class] = {false};
+	Bitmapset  *updated = NULL;
 	HeapTuple	tuple,
 				newtuple;
 	Relation	trigrel = NULL;
@@ -21386,17 +21493,13 @@ DetachPartitionFinalize(Relation rel, Relation partRel, bool concurrent,
 	Assert(((Form_pg_class) GETSTRUCT(tuple))->relispartition);
 
 	/* Clear relpartbound and reset relispartition */
-	memset(new_val, 0, sizeof(new_val));
-	memset(new_null, false, sizeof(new_null));
-	memset(new_repl, false, sizeof(new_repl));
-	new_val[Anum_pg_class_relpartbound - 1] = (Datum) 0;
-	new_null[Anum_pg_class_relpartbound - 1] = true;
-	new_repl[Anum_pg_class_relpartbound - 1] = true;
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(classRel),
-								 new_val, new_null, new_repl);
-
-	((Form_pg_class) GETSTRUCT(newtuple))->relispartition = false;
-	CatalogTupleUpdate(classRel, &newtuple->t_self, newtuple);
+	HeapTupleUpdateValueNull(pg_class, relpartbound, new_val, new_null, updated);
+	newtuple = heap_update_tuple(tuple, RelationGetDescr(classRel),
+								 new_val, new_null, updated);
+
+	HeapTupleUpdateField(pg_class, relispartition, false, (Form_pg_class) GETSTRUCT(newtuple), updated);
+	CatalogTupleUpdate(classRel, &newtuple->t_self, newtuple, updated, NULL);
+	bms_free(updated);
 	heap_freetuple(newtuple);
 	table_close(classRel, RowExclusiveLock);
 
@@ -21816,6 +21919,7 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 	int			tuples = 0;
 	HeapTuple	inhTup;
 	bool		updated = false;
+	Bitmapset  *updated_cols = NULL;
 
 	Assert(partedIdx->rd_rel->relkind == RELKIND_PARTITIONED_INDEX);
 
@@ -21868,10 +21972,11 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 				 RelationGetRelid(partedIdx));
 		indexForm = (Form_pg_index) GETSTRUCT(indTup);
 
-		indexForm->indisvalid = true;
+		HeapTupleUpdateField(pg_index, indisvalid, true, indexForm, updated_cols);
 		updated = true;
 
-		CatalogTupleUpdate(idxRel, &indTup->t_self, indTup);
+		CatalogTupleUpdate(idxRel, &indTup->t_self, indTup, updated_cols, NULL);
+		bms_free(updated_cols);
 
 		table_close(idxRel, RowExclusiveLock);
 		heap_freetuple(indTup);
diff --git a/src/backend/commands/tablespace.c b/src/backend/commands/tablespace.c
index 0b064891932..b7fe7abf86a 100644
--- a/src/backend/commands/tablespace.c
+++ b/src/backend/commands/tablespace.c
@@ -208,8 +208,8 @@ Oid
 CreateTableSpace(CreateTableSpaceStmt *stmt)
 {
 	Relation	rel;
-	Datum		values[Natts_pg_tablespace];
-	bool		nulls[Natts_pg_tablespace] = {0};
+	Datum		values[Natts_pg_tablespace] = {0};
+	bool		nulls[Natts_pg_tablespace] = {false};
 	HeapTuple	tuple;
 	Oid			tablespaceoid;
 	char	   *location;
@@ -325,12 +325,10 @@ CreateTableSpace(CreateTableSpaceStmt *stmt)
 	else
 		tablespaceoid = GetNewOidWithIndex(rel, TablespaceOidIndexId,
 										   Anum_pg_tablespace_oid);
-	values[Anum_pg_tablespace_oid - 1] = ObjectIdGetDatum(tablespaceoid);
-	values[Anum_pg_tablespace_spcname - 1] =
-		DirectFunctionCall1(namein, CStringGetDatum(stmt->tablespacename));
-	values[Anum_pg_tablespace_spcowner - 1] =
-		ObjectIdGetDatum(ownerId);
-	nulls[Anum_pg_tablespace_spcacl - 1] = true;
+	HeapTupleSetValue(pg_tablespace, oid, ObjectIdGetDatum(tablespaceoid), values);
+	HeapTupleSetValue(pg_tablespace, spcname, DirectFunctionCall1(namein, CStringGetDatum(stmt->tablespacename)), values);
+	HeapTupleSetValue(pg_tablespace, spcowner, ObjectIdGetDatum(ownerId), values);
+	HeapTupleSetValueNull(pg_tablespace, spcacl, values, nulls);
 
 	/* Generate new proposed spcoptions (text array) */
 	newOptions = transformRelOptions((Datum) 0,
@@ -338,13 +336,13 @@ CreateTableSpace(CreateTableSpaceStmt *stmt)
 									 NULL, NULL, false, false);
 	(void) tablespace_reloptions(newOptions, true);
 	if (newOptions != (Datum) 0)
-		values[Anum_pg_tablespace_spcoptions - 1] = newOptions;
+		HeapTupleSetValue(pg_tablespace, spcoptions, newOptions, values);
 	else
-		nulls[Anum_pg_tablespace_spcoptions - 1] = true;
+		HeapTupleSetValueNull(pg_tablespace, spcoptions, values, nulls);
 
 	tuple = heap_form_tuple(rel->rd_att, values, nulls);
 
-	CatalogTupleInsert(rel, tuple);
+	CatalogTupleInsert(rel, tuple, NULL);
 
 	heap_freetuple(tuple);
 
@@ -937,6 +935,7 @@ RenameTableSpace(const char *oldname, const char *newname)
 	HeapTuple	newtuple;
 	Form_pg_tablespace newform;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	/* Search pg_tablespace */
 	rel = table_open(TableSpaceRelationId, RowExclusiveLock);
@@ -996,14 +995,15 @@ RenameTableSpace(const char *oldname, const char *newname)
 
 	/* OK, update the entry */
 	namestrcpy(&(newform->spcname), newname);
-
-	CatalogTupleUpdate(rel, &newtuple->t_self, newtuple);
+	HeapTupleMarkColumnUpdated(pg_tablespace, spcname, updated);
+	CatalogTupleUpdate(rel, &newtuple->t_self, newtuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(TableSpaceRelationId, tspId, 0);
 
 	ObjectAddressSet(address, TableSpaceRelationId, tspId);
 
 	table_close(rel, NoLock);
+	bms_free(updated);
 
 	return address;
 }
@@ -1021,10 +1021,10 @@ AlterTableSpaceOptions(AlterTableSpaceOptionsStmt *stmt)
 	Oid			tablespaceoid;
 	Datum		datum;
 	Datum		newOptions;
-	Datum		repl_val[Natts_pg_tablespace];
+	Datum		values[Natts_pg_tablespace] = {0};
+	bool		nulls[Natts_pg_tablespace] = {false};
+	Bitmapset  *updated = NULL;
 	bool		isnull;
-	bool		repl_null[Natts_pg_tablespace];
-	bool		repl_repl[Natts_pg_tablespace];
 	HeapTuple	newtuple;
 
 	/* Search pg_tablespace */
@@ -1058,26 +1058,25 @@ AlterTableSpaceOptions(AlterTableSpaceOptionsStmt *stmt)
 	(void) tablespace_reloptions(newOptions, true);
 
 	/* Build new tuple. */
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
 	if (newOptions != (Datum) 0)
-		repl_val[Anum_pg_tablespace_spcoptions - 1] = newOptions;
+		HeapTupleUpdateValue(pg_tablespace, spcoptions, newOptions, values, nulls, updated);
 	else
-		repl_null[Anum_pg_tablespace_spcoptions - 1] = true;
-	repl_repl[Anum_pg_tablespace_spcoptions - 1] = true;
-	newtuple = heap_modify_tuple(tup, RelationGetDescr(rel), repl_val,
-								 repl_null, repl_repl);
+		HeapTupleUpdateValueNull(pg_tablespace, spcoptions, values, nulls, updated);
+	newtuple = heap_update_tuple(tup, RelationGetDescr(rel), values,
+								 nulls, updated);
 
 	/* Update system catalog. */
-	CatalogTupleUpdate(rel, &newtuple->t_self, newtuple);
+	CatalogTupleUpdate(rel, &newtuple->t_self, newtuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(TableSpaceRelationId, tablespaceoid, 0);
 
 	heap_freetuple(newtuple);
+	bms_free(updated);
 
 	/* Conclude heap scan. */
 	table_endscan(scandesc);
 	table_close(rel, NoLock);
+	bms_free(updated);
 
 	return tablespaceoid;
 }
